

stages:          # List of stages for jobs, and their order of execution
  - test
  - build
  - deploy

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - echo "Builing Project..."

unit-test-job:   # This job runs in the test stage.
  tags:
    - python-ledger
  stage: test    # It only starts when the job in the build stage completes successfully.
  image: python:3.11-slim-buster
  script:
    - echo "Running unit tests... This will take about 60 seconds."
    - echo "Installing pipEnv..."
    - pip install -U pipenv
    - echo "pipEnv installation completed."
    - echo "Creating virtual environment..."
    - pipenv install && pip install -r requirements.txt && python manage.py createsuperuser
    - echo "Virtual Environment Created Successfully."
    - python manage.py test django_ledger

# lint-test-job:   # This job also runs in the test stage.
#   stage: test    # It can run at the same time as unit-test-job (in parallel).
#   script:
#     - echo "Linting code... This will take about 10 seconds."
#     - sleep 10
#     - echo "No lint issues found."

deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  environment: production
  script:
    - echo "Deploying application..."
    - echo "Application successfully deployed."
